---
title: 'RTCPeerConnection: connectionstatechange event'
slug: Web/API/RTCPeerConnection/connectionstatechange_event
---
<div>{{WebRTCSidebar}}</div>

<p><span class="seoSummary">The <strong><code>connectionstatechange</code></strong> event is sent to the {{domxref("RTCPeerConnection.ontrack", "ontrack")}} event handler on an {{domxref("RTCPeerConnection")}} object after a new track has been added to an {{domxref("RTCRtpReceiver")}} which is part of the connection.</span> The new connection state can be found in {{domxref("RTCPeerConnection.connectionState", "connectionState")}}, and is one of the strings in the {{domxref("RTCPeerConnectionState")}} enumerated type.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("Event")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler</th>
   <td>{{domxref("RTCPeerConnection.onconnectionstatechange", "onconnectionstatechange")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>For an {{domxref("RTCPeerConnection")}}, <code>pc</code>, this example sets up a handler for <code>connectionstatechange</code> messages to handle changes to the connectivity of the WebRTC session. It calls an app-defined function called <code>setOnlineStatus()</code> to update a status display.</p>

<pre class="brush: js notranslate">pc.onconnectionstatechange = ev =&gt; {
  switch(pc.connectionState) {
    case "new":
    case "checking":
      setOnlineStatus("Connecting...");
      break;
    case "connected":
      setOnlineStatus("Online");
      break;
    case "disconnected":
      setOnlineStatus("Disconnecting...");
      break;
    case "closed":
      setOnlineStatus("Offline");
      break;
    case "failed":
      setOnlineStatus("Error");
      break;
    default:
      setOnlineStatus("Unknown");
      break;
  }
}
</pre>

<p>You can also create a handler for <code>connectionstatechange</code> by using {{domxref("EventTarget.addEventListener", "addEventListener()")}}:</p>

<pre class="brush: js notranslate">pc.addEventListener("connectionstatechange", ev =&gt; {
  switch(pc.connectionState) {
    /* ... */
  }
}, false);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebRTC 1.0', '#event-connectionstatechange', 'connectionstatechange')}}</td>
   <td>{{Spec2('WebRTC 1.0')}}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.connectionstatechange_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Connectivity">WebRTC connectivity</a></li>
 <li><a href="/en-US/docs/Web/API/WebRTC_API/Session_lifetime">Lifetime of a WebRTC session</a></li>
 <li>{{domxref("RTCPeerConnectionState")}}</li>
</ul>
